#pragma once

#include <uchar.h>
#include <stdint.h>

#define c8 uint8_t
#define c16 char16_t
#define c32 char32_t

#define u8 uint8_t
#define u16 uint16_t
#define u32 uint32_t
#define u64 uint64_t

#define i8 int8_t
#define i16 int16_t
#define i32 int32_t
#define i64 int64_t

#define f32 float
#define f64 double
#define f128 long double

#define uptr uintptr_t
#define iptr intptr_t

#define external extern
#define internal static
#define persistent static

#ifdef __cplusplus
#define class_mem static
#define BEGIN_C_LINKAGE extern "C" {
#define END_C_LINKAGE }
#endif // __cplusplus
